// C Source File
// Created 3/9/2004; 10:07:10 PM

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define RETURN_VALUE          // Return Pushed Expression
#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.01 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

float f(float x);
float simpsons_recursion(float a, float b,float err,short level, short level_max);
// Main Function
void _main(void)
{

	// Process arguments here if necessary.
  float a =0.0,b = 0.0,s=0.0;
  TRY
	ESI argptr = top_estack;
  a = estack_number_to_Float(argptr);
  argptr = next_expression_index (argptr);
  b = estack_number_to_Float(argptr);
  argptr = next_expression_index (argptr);
  s = simpsons_recursion(a,b,0.00001,0,5);
  ONERR
  	s=-1.0;
  ENDTRY
  while (GetArgType (top_estack) != END_TAG)  // Clean up arguments
    top_estack = next_expression_index (top_estack);
  top_estack--;

	// Remember to push an expression to the expression stack.
	push_Float(s);
}
float f(float x)
{
	return sqrt(2)*exp(-pow(x,2.0)/2)/(2*sqrt(PI));
}
float simpsons_recursion(float a, float b,float err,short level, short level_max)
{
	float h = (b-a)/2;
	float c = (b+a)/2;
	float one_simp = (h/3)*(f(a) + 4*f(c) + f(b));
	float d = (a + c)/2;
	float e = (c + b)/2;
	float two_simp = (h/6)*(f(a) + 4*f(d) + 2*f(c) + 4*f(e) + f(b));
	float y = 0.0;
	float right_simp = 0.0;
	float left_simp = 0.0;
	level = level+1;
/*	printf("level%i\n",level);
	printf("level_max%i\n",level_max);
	printf("a%fb%fc%f\nd%fe%f\n",a,b,c,d,e);
	printf("one_simp%f\n",one_simp);
	printf("two_simp%f\n",two_simp);
*/
	if(level < level_max)
	{
		if(abs(two_simp-one_simp) < 15*err)
		{
			y=two_simp + (two_simp - one_simp)/15;
		}
		else
		{
			left_simp = simpsons_recursion(a,c,err/2,level,level_max);
			right_simp = simpsons_recursion(c,b,err/2,level,level_max);
			y = left_simp + right_simp;			
		}
	}
	else
	{
		y=two_simp;
	}
//	printf("y%f ",y);
	return y;
}